DataMapping = {};
DataMapping.HistoryEntries = {};
DataMapping.InitiationHeader = {};
DataMapping.AcceptItem = {};
DataMapping.CheckOutItem = {};
DataMapping.CheckInItem = {};
DataMapping.Handlers = {};

-- Handlers
DataMapping.Handlers.RequestIdentifier = function()
    if (GetFieldValue("Transaction", "LibraryUseOnly") == true) then
        return "LU";
    else
        return "TN";
    end
end

-- Library Use Only Conditional Mappings
DataMapping.Handlers.ApplicationProfileType = function ()
	if (GetFieldValue("Transaction", "LibraryUseOnly") == true) then
		return "ILL_LU";
	else
		return "ILL";
	end
end

-- Request Identifier Prefix
DataMapping.RequestIdentifierPrefix = "{Custom:RequestIdentifier}";

-- Constants
DataMapping.ItemBarcodeField = "{TableField:Setting.ItemBarcodeField}"; -- This is the field of the transactions table that is used to check for an item barcode. The temporary barcode of an AcceptItem will also be store in this field.
DataMapping.TemporaryItemBarcodeFormat = "{Custom:RequestIdentifier}-{TableField:Transaction.TransactionNumber}"; -- The formatting used to create an item barcode for temporary items
DataMapping.SendInitiationHeaders = true;

-- InitiationHeader Values
DataMapping.InitiationHeader.FromAgencyId = "{TableField:Setting.FromAgencyId}"; -- The agency id used for the InitiationHeader FromAgencyId
DataMapping.InitiationHeader.ToAgencyId = "{TableField:Setting.ToAgencyId}"; -- The agency id used for the InitiationHeader ToAgencyId
DataMapping.InitiationHeader.ApplicationProfileType = "{TableField:Setting.ApplicationProfileType}"; -- The ApplicationProfile type used for the InitiationHeader

-- AcceptItem Values
DataMapping.AcceptItem.RequestAgencyId = ""; -- The agency id used for the AcceptItem RequestId
DataMapping.AcceptItem.RequestIdentifierType = "Barcode Id"; -- The request identifier type used for the AcceptItem RequestId
DataMapping.AcceptItem.RequestIdentifierValue = DataMapping.TemporaryItemBarcodeFormat; -- The request identifier value used for the AcceptItem RequestId --"32044082370859";
DataMapping.AcceptItem.RequestedActionType = "Hold For Pickup"; -- The RequestedActionType used for the AcceptItem message
DataMapping.AcceptItem.UserAgencyId = ""; -- The value used for the user agencyid
DataMapping.AcceptItem.UserIdentifierType = "Barcode Id"; -- The value used for the user identifier type of the AcceptItem UserId
DataMapping.AcceptItem.ItemAgencyId = ""; -- The value used for the item agencyid
DataMapping.AcceptItem.ItemIdentifierType = "Barcode Id"; -- The value used for the item identifier type of the AcceptItem ItemId
DataMapping.AcceptItem.OptionalTitle = "{TableField:Transaction.LoanTitle}";
DataMapping.AcceptItem.OptionalAuthor = "{TableField:Transaction.LoanAuthor}";

-- PickupLocations
DataMapping.AcceptItem.PickupLocation = "{TableField:Setting.PickupLocation}"; -- The value used for the PickupLocation of the AcceptItem message

-- CheckOutItem Values
DataMapping.CheckOutItem.SendRequestId = true;
DataMapping.CheckOutItem.RequestAgencyId = ""; -- The agency id used for the AcceptItem RequestId
DataMapping.CheckOutItem.RequestIdentifierType = "Barcode Id"; -- The request identifier type used for the AcceptItem RequestId
DataMapping.CheckOutItem.RequestIdentifierValue = DataMapping.TemporaryItemBarcodeFormat; -- The request identifier value used for the CheckOut RequestId
DataMapping.CheckOutItem.UserAgencyId = ""; -- The value used for the user agencyid
DataMapping.CheckOutItem.UserIdentifierType = "Barcode Id"; -- The value used for the user identifier type of the CheckOutItem UserId
DataMapping.CheckOutItem.ItemAgencyId = ""; -- The value used for the item agencyid
DataMapping.CheckOutItem.ItemIdentifierType = "Barcode Id"; -- The value used for the item identifier type of the CheckOutItem ItemId

-- CheckInItem Values
DataMapping.CheckInItem.ItemAgencyId = ""; -- The value used for the item agencyid
DataMapping.CheckInItem.ItemIdentifierType = "Barcode Id"; -- The value used for the item identifier type of the CheckInItem ItemId
DataMapping.CheckInItem.ItemIdentifierValue = "{TableField:Transaction." .. DataMapping.ItemBarcodeField .. "}"; -- The value used for the item identifier value of the CheckInItem ItemId
